import qt
from qt import *

def getConfig():
    import cbar
    import kdecore
    cbarInterface = cbar.Cbar()
    cbarName = cbarInterface.getCbarName()
    
    kconfig = kdecore.KConfig(cbarName + "/cbarrc")
    return kconfig

class DefaultScriptLoader(qt.QObject):
    import qt
    class DefaultScriptManagerWindow(qt.QDialog):
        import qt
        class ScriptListViewItem(qt.QListViewItem):
            def __init__(self, scriptParams, *args):
                import qt
                apply(qt.QListViewItem.__init__, (self,) + args)
                self.scriptParams = scriptParams
                self.updateTexts()
            def getParams(self):
                return self.scriptParams
            def enabledText(self, value):
                if value == True:
                    return "Enabled"
                else:
                    return "Disabled"
                
            def updateTexts(self):
                self.setText(0, self.scriptParams["name"])
                self.setText(1, self.enabledText(self.scriptParams["enabled"]))
                
        def __init__(self,parent = None,name = None,modal = 0,fl = 0):
            import qt
            import kdeui
            qt.QDialog.__init__(self,parent,name,modal,fl)
    
            if not name:
                self.setName("Configure scripts")
    
    
            Form1Layout = qt.QGridLayout(self,1,1,11,6,"Form1Layout")
    
            self.line1 = qt.QFrame(self,"line1")
            self.line1.setFrameShape(qt.QFrame.HLine)
            self.line1.setFrameShadow(qt.QFrame.Sunken)
            self.line1.setFrameShape(qt.QFrame.HLine)
    
            Form1Layout.addMultiCellWidget(self.line1,2,2,0,1)
    
            layout7 = qt.QHBoxLayout(None,0,6,"layout7")
            spacer2 = qt.QSpacerItem(40,20,qt.QSizePolicy.Expanding,qt.QSizePolicy.Minimum)
            layout7.addItem(spacer2)
    
            self.okButton = kdeui.KPushButton(self,"okButton")
            self.okButton.setProperty("stdItem",qt.QVariant(1))
            layout7.addWidget(self.okButton)
    
            self.cancelButton = kdeui.KPushButton(self,"cancelButton")
            self.cancelButton.setProperty("stdItem",qt.QVariant(2))
            layout7.addWidget(self.cancelButton)
    
            Form1Layout.addMultiCellLayout(layout7,3,3,0,1)
    
            layout4 = qt.QVBoxLayout(None,0,6,"layout4")
    
            self.scriptsList = qt.QListView(self,"scriptsList")
            self.scriptsList.addColumn(self.__tr("Script"))
            self.scriptsList.addColumn(self.__tr("Enabled"))
            self.scriptsList.setResizePolicy(qt.QListView.AutoOneFit)
            self.scriptsList.setShowSortIndicator(1)
            layout4.addWidget(self.scriptsList)
    
            layout2 = qt.QHBoxLayout(None,0,6,"layout2")
    
            self.textLabel1 = qt.QLabel(self,"textLabel1")
            layout2.addWidget(self.textLabel1)
    
            self.scriptNameField = qt.QLabel(self,"scriptNameField")
            layout2.addWidget(self.scriptNameField)
            layout4.addLayout(layout2)
    
            layout2_2 = qt.QHBoxLayout(None,0,6,"layout2_2")
    
            self.textLabel1_2 = qt.QLabel(self,"textLabel1_2")
            layout2_2.addWidget(self.textLabel1_2)
    
            self.scriptPathField = qt.QLabel(self,"scriptPathField")
            layout2_2.addWidget(self.scriptPathField)
            layout4.addLayout(layout2_2)
    
            self.textLabel3 = qt.QLabel(self,"textLabel3")
            layout4.addWidget(self.textLabel3)
    
            self.scriptDescriptionField = qt.QTextBrowser(self,"scriptDescriptionField")
            self.scriptDescriptionField.setMinimumSize(qt.QSize(60,0))
            layout4.addWidget(self.scriptDescriptionField)
    
            Form1Layout.addMultiCellLayout(layout4,0,1,0,0)
    
            self.enableToggleButton = qt.QPushButton(self,"enableToggleButton")
            self.enableToggleButton.setEnabled(False)
    
            Form1Layout.addWidget(self.enableToggleButton,0,1)
            spacer1 = qt.QSpacerItem(100,546,qt.QSizePolicy.Minimum,qt.QSizePolicy.Expanding)
            Form1Layout.addItem(spacer1,1,1)
    
            self.languageChange()
            
            self.connect(
                self.okButton,
                qt.SIGNAL("clicked()"),
                self,
                qt.SLOT("accept()")
                )
            self.connect(
                self.cancelButton,
                qt.SIGNAL("clicked()"),
                self,
                qt.SLOT("reject()")
                )
            self.connect(
                self.enableToggleButton,
                qt.SIGNAL("clicked()"),
                self.toggleScriptEnabled
                )
            self.connect(
                self.scriptsList,
                qt.SIGNAL("pressed(QListViewItem *)"),
                self.itemSelected
                )
                
            self.loadAvailableScripts()
                
            self.resize(qt.QSize(590,653).expandedTo(self.minimumSizeHint()))
            self.clearWState(qt.Qt.WState_Polished)
        def toggleScriptEnabled(self):
            item = self.scriptsList.currentItem()
            item.getParams()["enabled"] = not item.getParams()["enabled"]
            item.updateTexts()
            self.updateToggleEnableButton()
        def updateToggleEnableButton(self):
            item = self.scriptsList.currentItem()
            if item == None:
                self.enableToggleButton.setEnabled(False)
                return
            self.enableToggleButton.setEnabled(True)
            if item.getParams()["enabled"]:
                self.enableToggleButton.setText("Disable")
            else:
                self.enableToggleButton.setText("Enable")
        def itemSelected(self, item):
            self.updateToggleEnableButton()
            self.updateScriptInfo()
        def updateScriptInfo(self):
            item = self.scriptsList.currentItem()
            if item == None:
                self.scriptNameField.setText("")
                self.scriptPathField.setText("")
                self.scriptDescriptionField.setText("")
                return
            self.scriptNameField.setText(item.getParams()["name"])
            self.scriptPathField.setText(item.getParams()["path"])
            self.scriptDescriptionField.setText(item.getParams()["description"])
            
            
        def loadAvailableScripts(self):
            import kdecore
            import qt
            global getConfig
            #Desktop files handling copied from Konqueror sidebar
            s = ""
            desktopFileNames = kdecore.KGlobal.dirs().findAllResources(
                "data",
               "cbar/scripts/*.desktop"
               )
            cbarConfig = getConfig()
            cbarConfig.setGroup("ScriptsToLoad")
            enabledScriptsList = cbarConfig.readPathListEntry("scripts") #entryName, default
            enabledScripts = {}
            for scriptPath in enabledScriptsList:
                enabledScripts[str(scriptPath)] = 1
            
            for desktopFileName in desktopFileNames:
                scriptParams = {}
                s += str(desktopFileName) +"\n"
                scriptDesktopFile = kdecore.KSimpleConfig(desktopFileName)
                scriptDesktopFile.setGroup("Desktop Entry")
                scriptParams["name"] = str(scriptDesktopFile.readEntry("Name"))
                scriptBaseName = str(scriptDesktopFile.readEntry("X-KDE-Cbar-Script"))
                scriptParams["path"] = str(kdecore.locate("data", "cbar/scripts/" + str(scriptBaseName)))
                scriptParams["description"] = str(scriptDesktopFile.readEntry("Comment"))
                
                if enabledScripts.has_key(scriptParams["path"]):
                    scriptParams["enabled"] = True
                else:
                    scriptParams["enabled"] = False
                
                s += "Name=%s\nX-KDE-Cbar-Script=%s\nenabled=%s\n" % (
                    scriptParams["name"],
                    scriptParams["path"],
                    str(scriptParams["enabled"])
                    )
                item = self.ScriptListViewItem(
                    scriptParams, 
                    self.scriptsList
                    )
        
        def getEnabledScripts(self):
            item = self.scriptsList.firstChild()
            enabledScripts = []
            while item != None:
                if item.getParams()["enabled"]:
                    enabledScripts.append(item.getParams()["path"])
                item = item.nextSibling()
            return enabledScripts
    
        def languageChange(self):
            import qt
            self.setCaption(self.__tr("Configure scripts"))
            self.okButton.setText(self.__tr("O&K"))
            self.okButton.setAccel(self.__tr("Alt+K"))
            self.cancelButton.setText(self.__tr("&Anuluj"))
            self.cancelButton.setAccel(self.__tr("Alt+A"))
            self.scriptsList.header().setLabel(0,self.__tr("Script"))
            self.scriptsList.header().setLabel(1,self.__tr("Enabled"))
            self.textLabel1.setText(self.__tr("Script name:"))
            self.scriptNameField.setText(qt.QString.null)
            self.textLabel1_2.setText(self.__tr("Script path:"))
            self.scriptPathField.setText(qt.QString.null)
            self.textLabel3.setText(self.__tr("Script description:"))
            self.enableToggleButton.setText(self.__tr("En&able"))
            self.enableToggleButton.setAccel(self.__tr("Alt+A"))
    
        def __tr(self,s,c = None):
            import qt
            return qt.qApp.translate("DefaultScriptManagerWindow",s,c)
    
    import qt
    def __init__( self, *args ):
        import qt
        apply(qt.QObject.__init__, (self,) + args)
        self.register()
        
    def openScriptManager(self):
        import qt
        scriptManager = self.DefaultScriptManagerWindow()
        result = scriptManager.exec_loop()
        if result == qt.QDialog.Accepted:
            enabledScripts = scriptManager.getEnabledScripts()
            self.writeEnabledScripts(enabledScripts)
            
    def writeEnabledScripts(self, enabledScripts):
        import qt
        global getConfig
        global executeScript
        
        qlist = qt.QStringList()
        newEnabledSet = set(enabledScripts)
        
        for s in enabledScripts:
            qlist.append(qt.QString(s))
        
        kconfig = getConfig()
        kconfig.setGroup("ScriptsToLoad")
        oldScripts = kconfig.readPathListEntry("scripts")
        kconfig.writePathEntry("scripts", qlist)
        kconfig.sync()
        
        oldEnabledSet = set()
        
        for oldScriptPath in oldScripts:
            oldEnabledSet.add(str(oldScriptPath))
        
        for scriptPath in newEnabledSet.difference(oldEnabledSet):
            executeScript(scriptPath)
            
        if len(oldEnabledSet.difference(newEnabledSet)) != 0:
            qt.QMessageBox.warning(None, "Application restart needed", "Dynamic unloading of scripts is not yet implemented.\nPlease restart application for the changes to make effect.")
        
    def register(self):
        import qt
        import cbar
        cbarInterface = cbar.Cbar()
        connectionObject = cbarInterface.registerScriptLoader(self)
        qt.QObject.connect(
            connectionObject,
            qt.SIGNAL("signalOpenScriptManager()"),
            self.openScriptManager
            )

def executeScript(scriptPath):
    import cbar
    cbarInterface = cbar.Cbar()
    cbarInterface.executeScript(scriptPath)

def loadScriptsFromConfig(kconfig):
    """Loads scripts given by config.
    NOTE: Loading script _must_ be done from toplevel of script,
    not from class, otherwise it does not work (why???).
    """
    global executeScript
    
    import kdecore
    import qt
    kconfig.setGroup("ThemeManager")
    themeManagerPath = kconfig.readEntry("scriptPath")
    if len(themeManagerPath) == 0:
        themeManagerPath = kdecore.locate("data", "cbar/scripts/" + "defaultThemeManager.py")
    if len(themeManagerPath) == 0:
        raise Exception, "Cannot find any theme manager"
    executeScript(str(themeManagerPath))
    
    kconfig.setGroup("ScriptsToLoad")
    scripts = kconfig.readPathListEntry("scripts") #entryName, default
    for scriptPath in scripts:
        executeScript(str(scriptPath))

scriptLoader = DefaultScriptLoader()
loadScriptsFromConfig(getConfig())


