import cbar
import qt
from kio import *

class OpenWithWidget(qt.QWidget):
    import kdeui
    class ServiceRunKurlLabel(kdeui.KURLLabel):
        def __init__( self, desktopEntryPath, *args ):
            import kdeui
            import qt
            apply(kdeui.KURLLabel.__init__, (self,) + args )
            self.desktopEntryPath = desktopEntryPath
            qt.QObject.connect(
                self, 
                qt.SIGNAL("leftClickedURL(const QString&)"),
                self.clickedLabel
                )
        def clickedLabel(self, url):
            import qt
            import kio
            import kdecore
            service = kio.KService(kdecore.KDesktopFile(self.desktopEntryPath) )
            urlList = kdecore.KURL.List()
            urlList.append(kdecore.KURL(url))
            result = kio.KRun.run(service, urlList)
            if (result == 0):
                qt.QMessageBox.error(self, "Failed to open", u"Failed to run application\n desktop=%s\nurl=%s" % (self.desktopEntryPath, self.url()))
    def __init__( self, *args ):
        import qt
        apply(qt.QWidget.__init__, (self,) + args )
        layout = qt.QVBoxLayout(self)
        self.setSizePolicy(qt.QSizePolicy(qt.QSizePolicy.Expanding, qt.QSizePolicy.Expanding))
        self. setMaximumWidth(300)
        self.openWidgetsList = []
        
    def removeOpenLabels(self):
        for widget in self.openWidgetsList:
            widget.hide()
            #Note: removeChild() causes some crashes in Konqueror when opening new tab
            #self.removeChild(widget)
            widget.deleteLater()
        self.openWidgetsList = []

    def itemsSelected(self, items):
        import qt
        if len(items) == 1:
            selectedItem = items[0]
            self.loadOpenWith(selectedItem.mimetype(), selectedItem.url())
        else:
            self.removeOpenLabels()
            self.hide()
    def loadOpenWith(self, mimetype, url):
        import kio
        import qt
        offers = kio.KTrader.self().query(mimetype, "Type == 'Application'")
        
        s = ""
        self.setUpdatesEnabled(False)
        self.removeOpenLabels()
        for offer in offers:
            label = self.ServiceRunKurlLabel(offer.desktopEntryPath(), self)
            label.setText(offer.name())
            label.setURL(url.url())
            label.setFloat(False)
            label.setUnderline(False)
            s += u"Name=%s icon=%s desktopEntryPath=%s\n" % (offer.name(), offer.icon(), offer.desktopEntryPath())
            self.layout().addWidget(label, 0, qt.Qt.AlignLeft | qt.Qt.AlignTop)
            self.openWidgetsList.append(label)
            label.show()

        if len(self.openWidgetsList) == 0:
            self.hide()
        else:
            self.show()
        self.setUpdatesEnabled(True)

widget = OpenWithWidget()

cbarInterface = cbar.Cbar()

params = { "type": "Open with"}

connectionObject = cbarInterface.addCbarWidget(widget, params)
qt.QObject.connect(
    connectionObject,
    qt.SIGNAL("signalItemsSelected(const KFileItemList &)"),
    widget.itemsSelected
    )
