import cbar
import qt
from kio import *

class PlaceLabelWidget(qt.QWidget):
    def __init__( self, *args ):
        import qt
        apply(qt.QWidget.__init__, (self,) + args )
        layout = qt.QVBoxLayout(self)
        self.setSizePolicy(qt.QSizePolicy(qt.QSizePolicy.Expanding, qt.QSizePolicy.Expanding))
        self.addPlace(
            "media:/", 
            "Removable media", 
            "Removable devices"
            )
        self.addPlace(
            "home:/", 
            "Home folder", 
            "Folder containing your personal files"
            )
    def addPlace(self, url, text, tooltip):
        import kdeui
        import qt
        newLabel = kdeui.KURLLabel(self)
        newLabel.setText(text)
        newLabel.setURL(url)
        newLabel.setTipText(tooltip)
        newLabel.setUseTips()
        newLabel.setFloat()
        newLabel.setUnderline(0)
        self.layout().addWidget(newLabel, 0, qt.Qt.AlignLeft | qt.Qt.AlignTop)
        qt.QObject.connect(
            newLabel, 
            qt.SIGNAL("leftClickedURL(const QString&)"),
            self.clickedPlaceLabel
            )
        self.layout().addStretch(10)
    def clickedPlaceLabel(self, url):
        import qt
        import dcopext
        import kdecore
        dcop = kdecore.KApplication.dcopClient()
        dcopObj = dcopext.DCOPObj (
            kdecore.KApplication.dcopClient().appId(), 
            dcop,
            self.topLevelWidget().name()
            )
        ok = dcopObj.openURL(url)

widget = PlaceLabelWidget()

cbarInterface = cbar.Cbar()
connectionObject = cbarInterface.addCbarWidget(widget, {"type" : "Places"})
