
#ifndef CBAR_H
#define CBAR_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <konqsidebarplugin.h>
#include <qstring.h>
#include <kconfig.h>

#include "../cbarlib/cbarlib.h"


class CbarSidebar : public KonqSidebarPlugin
{
    Q_OBJECT
    
public:
    /**
     * Construct a @ref KonqSidebarPlugin.
     *
     * @param inst The sidebar's kinstance class.
     * @param parent The sidebar internal button info class responsible for this plugin.
     * @param widgetParent The container which will contain the plugins widget.
     * @param desktopName The filename of the configuration file.
     * @param name A Qt object name for your plugin.
     **/
     CbarSidebar(KInstance *inst,QObject *parent,QWidget *widgetParent, QString &desktopName, const char* name=0);

    /** destructor */
    ~CbarSidebar();
    
   virtual QWidget *getWidget(){return widget.data();}
   virtual void *provides(const QString &) {return 0;}

protected:
    CbarWidget::Ptr  widget;
    ///Inherited from KonqSidebarPlugin
    virtual void handleURL(const KURL &url);
    ///Inherited from KonqSidebarPlugin
    virtual void handlePreview(const KFileItemList & items);

};

#endif
